import type { LibuildPlugin } from '@modern-js/libuild';
import type { TransformOptions as BabelTransformOptions } from '@babel/core';
export interface BabelPluginImportOptions {
    libraryName: string;
    /**
     * @default "lib"
     */
    libraryDirectory?: string;
    /**
     * @default true
     */
    camel2DashComponentName?: boolean;
    style: boolean | ((name: string) => string);
    styleLibraryDirectory?: string;
    customName?: string;
    customStyleName?: string;
    transformToDefaultImport?: boolean;
}
export interface BabelReactOptions {
    /**
     * @default "React.createElement" (only in classic runtime)
     */
    pragma?: string;
    /**
     * @default "React.Fragment" (only in classic runtime)
     */
    pragmaFrag?: string;
    /**
     * @default true
     */
    throwIfNamespace?: boolean;
    /**
     * @default "classic"
     */
    runtime?: 'classic' | 'automatic';
    /**
     * @default "react"  (only in automatic runtime)
     */
    importSource?: string;
}
export interface BabelPresetOption {
    /**
     * @description babel-plugin-import options
     */
    import?: BabelPluginImportOptions | BabelPluginImportOptions[];
    /**
     * @description @babel/preset-react options.
     */
    react?: BabelReactOptions;
}
export declare const babelPresetPlugin: (preset?: BabelPresetOption, options?: BabelTransformOptions) => LibuildPlugin;
